<template lang="pug">
  .related
    b-notification(type="is-warning" :closable="false" v-if="noIssue")
      .tc.ma2
        .mid-gray 沒有其他通報了～
    div(v-else)
      nuxt-link.db.br2.bg-white.b--light-silver.pa2.mv2.dim(
        v-for="issue in issues"
        :key="issue.id"
        :to="issueLink(issue)"
      )
        .mb2
          state-tag.w-100(:value="issue.state")
        .flex.justify-between.items-end
          .black.f6 {{zh(issue.taskType)}}
          .gray.f7  {{issue.atUpdatedAt.fromNow()}}

</template>
<script>
import api from '~/utils/api'
import StateTag from '~/components/StateTag'
import { issueMixin } from '~/utils/mixins'

export default {
  components: {
    StateTag
  },
  mixins: [issueMixin],
  props: {
    booking: {
      type: Object,
      required: true
    },
    curIssueId: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      issues: [],
      hasInit: false
    }
  },
  computed: {
    noIssue () {
      return this.hasInit && this.issues.length === 0
    }
  },
  watch: {
    booking () {
      this.getIssues()
    }
  },
  created () {
    this.getIssues()
  },
  methods: {
    async getIssues () {
      // TODO: pagination, correct filter
      // TODO: messenger disappear sometimes
      const issues = []
      const sameEmail = await api.issue.find({
        // id: { $ne: this.curIssueId },
        reporterEmail: this.booking.email
      })
      issues.push(...sameEmail.data)

      const sameRoom = await api.issue.find({
        // id: { $ne: this.curIssueId },
        buildingId: this.booking.buildingId,
        roomId: this.booking.roomId
        // reporterEmail: { $ne: this.booking.email }
      })
      if (sameRoom.total) {
        issues.push(...sameRoom.data)
      }
      const issueMap = {}
      this.issues = issues.filter((issue) => {
        if (issueMap[issue.id]) {
          return false
        }
        issueMap[issue.id] = true
        if (issue.id === this.curIssueId) {
          return false
        }
        return true
      })
      this.hasInit = true
    },
    issueLink (issue) {
      return `/item/${issue.id}`
    }
  }
}
</script>
